package sgbd.impl;

import sgbd.stockage.Fichier;
import sgbd.stockage.Nuplet;

import java.io.*;

public class FichierInt implements Fichier{

	private String fp;
	private RandomAccessFile f;
	private byte position; // l'utilisation d'un byte pour la position peut tre limitative
	private byte nupletSize;
	private byte currentLength;
	private int headerSize=2; // Nombre d'attributs et nombre de lignes
	
	public FichierInt(String filePath, byte nupletSize){
		this.fp = filePath;
		this.nupletSize = nupletSize;
	}

	public void store(int pos, Object o) {
		try {
			this.f = new RandomAccessFile(this.fp, "rw");
			byte[] head = new byte[2];
			head[0] = this.nupletSize;
			head[1] = ++this.currentLength;
			this.f.write(head);
			NupletInt n = (NupletInt) o;
			byte[] b = new byte[nupletSize];
			for(int i=0;i<nupletSize;i++)
				b[i] = (byte)((NupletInt) o).getAtt(i);
			this.f.seek(pos*nupletSize+headerSize);
			this.f.write(b);
			this.f.close();
		} catch (Exception e) {
			e.printStackTrace();
		}
	}
	
	@Override
	public void open(){
		try {
			this.f = new RandomAccessFile(this.fp, "rw");
			this.position = 0;
			byte[] head = new byte[2];
			this.f.seek(0);
			this.f.read(head);
			this.nupletSize = head[0];
			this.currentLength = head[1];
		} catch (Exception e) {
			e.printStackTrace();
		}
	}
	
	public Nuplet next(){
		try {
			byte[] b = new byte[nupletSize];
			this.f.seek(this.position*nupletSize+headerSize);
			this.f.read(b);
			Nuplet n = new NupletInt(b);
			if (this.position < this.currentLength){
				this.position++;
				return n;
			}
			else
				return null;
		} catch (Exception e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
			return null;
		}
	}
	
	@Override
	public void close(){
		try {
			f.close();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}

	@Override
	public Object get(int pos) {
		try {
			this.f = new RandomAccessFile(this.fp, "rw");
			byte[] head = new byte[2];
			this.f.seek(0);
			this.f.read(head);
			this.nupletSize = head[0];
			this.position = head[1];
			byte[] b = new byte[nupletSize];
			this.f.seek(pos*nupletSize+headerSize);
			f.read(b);
			f.close();
			return new NupletInt(b);
		} catch (Exception e) {
			e.printStackTrace();
			return null;
		}
	}

	@Override
	public long getCurrentSize() {
		return this.currentLength;
	}
	
	

}
