package sgbd.impl;

import sgbd.operateurs.Operateur;
import sgbd.operateurs.Restriction;
import sgbd.stockage.Nuplet;
import sgbd.stockage.Table;

public class RestrictionEgalite implements Restriction {
	
	public Operateur source;
	private byte colonne;
	private byte value;
	
	public RestrictionEgalite(Operateur s, byte c, byte v){
		this.source = s;
		this.colonne = c;
		this.value = v;
	}

	@Override
	public void open() {
		this.source.open();
		
	}

	@Override
	public void close() {
		this.source.close();
	}

	@Override
	public Nuplet next() {
		try{
		Nuplet n=this.source.next();
		while (n != null){
			if((byte)n.getAtt(this.colonne)==this.value)
				return n;
			n = this.source.next();
		}
		return null;
		}
		catch(Exception e){
			return null;
		}
	}

}
