package sgbd.impl;

import java.util.Vector;

import sgbd.stockage.Nuplet;
import sgbd.stockage.Table;

public class TableInt implements Table{
	
	private byte records;
	private int position;
	FichierInt f;
	
	public TableInt(String filePath, byte nupletSize){
		this.records = 0;
		this.position = 0;
		this.f = new FichierInt(filePath, nupletSize);
	}

	@Override
	public Nuplet get(int pos) {
		return (Nuplet) f.get(pos);
	}

	@Override
	public byte size() {
		return this.records;
	}

	@Override
	public void put(Nuplet n) {
		f.store(this.records, n);
		this.records++;
	}
	
	@Override
	public void open(){
		this.f.open();
		this.position=0;
	}
	
	@Override
	public void close(){
		this.f.close();
	}

	/** Cette mthode peut tre amliore par un index !
	 * 
	 */
	@Override
	public Nuplet[] getByAtt(int att, Object value) {
		Vector<Nuplet> v = new Vector<Nuplet>();
		for(int i=0;i<this.size();i++){
			Nuplet temp = this.get(i);
			if((byte)(temp.getAtt(att)) == (byte)value){
				v.addElement(temp);
			}
		}
		Nuplet[] ret = new Nuplet[v.size()];
		for(int i=0;i<v.size();i++)
			ret[i] = v.elementAt(i);
		return ret;
	}

	@Override
	public void insert(Nuplet n) {
		// TODO Auto-generated method stub
		
	}

	@Override
	public void delete(byte att, Object value) {
		// TODO Auto-generated method stub
		
	}

	@Override
	public void update(byte att1, Object value, byte att2, Object newValue) {
		// TODO Auto-generated method stub
		
	}

	@Override
	public Nuplet next() {
		try{
			this.position++;
			return this.f.next();
		}catch(Exception e)
		{
			return null;
		}
	}

	@Override
	public void commit() {
		// TODO Auto-generated method stub
		
	}

	@Override
	public void rollback() {
		// TODO Auto-generated method stub
		
	}

}
