package sgbd.stockage;

import sgbd.operateurs.Operateur;

public interface Table extends Operateur{
	
	public Nuplet get(int pos);
	// Mthodes implmentes actuellement en fullscan

	// on pourrait rajouter ici d'autres mthodes si on utilise par exemple un index pour accder aux donnes de la table
	public Nuplet[] getByAtt(int att, Object value); // Rcupre les nuplets qui ont la valeur value sur l'attribut nr att
	public byte size();
	public void put(Nuplet n);
	public void insert(Nuplet n);
	public void delete(byte att, Object value); // efface tous les Nuplets dont att est gal  value
	public void update(byte att1, Object oldValue, byte att2, Object newValue); // modifie tous les Nuplets dont att tait gal  oldValue et met l'attribut att2  la valeur newValue
	public void commit();
	public void rollback();
}
