package sgbd.test;

import sgbd.impl.RestrictionEgalite;
import sgbd.impl.TableInt;
import sgbd.operateurs.Restriction;
import sgbd.stockage.Nuplet;
import sgbd.stockage.Table;

public class ExempleLecture {

	public static final byte datasetSize = 100;
	public static final byte nupletSize = 10;
	
	public static void main(String[] args){
		Table t = new TableInt("C:/temp/table3", nupletSize);
		Nuplet n;
		System.out.println("***FULL SCAN***");
		// FULL SCAN
		t.open();
		while((n=t.next())!=null){
			System.out.println(n);
		}
		t.close();
		
		// RESTRICTION
		System.out.println("***RESTRICTION EGALITE***");
		Restriction r = new RestrictionEgalite(t, (byte)0, (byte)2);
		r.open();
		while((n=r.next())!=null){
			System.out.println(n);
		}
		
		r.close();
		
		// DOUBLE RESTRICTION
		System.out.println("***RESTRICTION EGALITE DOUBLE***");
		Restriction r1 = new RestrictionEgalite(t, (byte)1, (byte)1);
		Restriction r2 = new RestrictionEgalite(r1, (byte)2, (byte)2);
		/*
		r2.source = t;
		r1.source = r2;
*/
		
		r2.open();
		while((n=r2.next())!=null){
			System.out.println(n);
		}
		r2.close();
		
	}
	
}

